#!/usr/bin/perl
#
#  usage: ./compute_shifts.pl trace.prv
#  generates: file with offsets needed to synchronize across all processes
#             the start time of the last useful state
#


open(Y,$ARGV[0]);

$maxprocess=0;
$maxtime=0;

for ($i=1; $i <=2000; $i++){
 $tstart[$i]=0;
}

while ($line=<Y>) {
  chop ($line);
  @fields=split(/:/,$line);

  if (($fields[0] == 2) && ($fields[6]==50000002) && ($fields[7]==0)) {
    $process = $fields[3];
    $time = $fields[5];
    if ($process > $maxprocess) {$maxprocess = $process;};
    if ($time > $maxtime) {$maxtime = $time;};
    $tstart[$process] = $time;
  } 
}

#print "max time = ".$maxtime."\n" ;

for ($i=1; $i <=$maxprocess; $i++){
    if ($tstart[$i] ==0) {print "0\n";}
    else {
       $delta = $maxtime - $tstart[$i];
       print $delta."\n" ;
    }
    
}

close(Y);

